/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { Type, markType, Point_$type, enumGetBox, typeCast } from "igniteui-react-core/ES2015/type";
import { isNaN_, intDivide, isInfinity } from "igniteui-react-core/ES2015/number";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { TrendLineType_$type } from "igniteui-react-core/ES2015/TrendLineType";
import { Brush } from "igniteui-react-core/ES2015/Brush";
import { PenLineCap_$type } from "igniteui-react-core/ES2015/PenLineCap";
import { DoubleCollection } from "igniteui-react-core/ES2015/DoubleCollection";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-react-core/ES2015/IFastItemsSource";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-react-core/ES2015/Clipper";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { stringIsNullOrEmpty } from "igniteui-react-core/ES2015/string";
/**
 * @hidden
 */
export class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = this.f.cs.np;
        let c = Math.min(a * this.b, b.count - 1);
        let d = Math.min(c + this.b - 1, b.count - 1);
        let e = NaN;
        let f = NaN;
        for (let g = c; g <= d; ++g) {
            let h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    }
}
AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
/**
 * @hidden
 */
export class AnchoredRadialSeries extends RadialBase {
    constructor() {
        super();
        this.nk = null;
        this.no = null;
        this.oi = { $type: Point_$type, x: 0, y: 0 };
        this.nm = null;
        this.nl = null;
        this.nm = new RadialFrame(3);
        this.nk = new CategoryLineRasterizer();
    }
    bf() {
        return new AnchoredRadialSeriesView(this);
    }
    hn() {
        super.hn();
        this.mt = null;
        this.mv = null;
    }
    im(a) {
        super.im(a);
        this.nj = a;
    }
    fb(a, b) {
        return this.fc(a, b, this.mt, null, this.np);
    }
    e9(a, b) {
        return this.fa(a, b, this.mt, null, this.np);
    }
    d6(a, b, c, d, e) {
        if (this.np == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.d7(a, b, this.mt, d, e, this.np.count, null);
    }
    ek(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.nu(this.mt, this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mt.b8, d);
        f.c = this.bs.m3;
        return this.em(this.np, a, this.mt, f, e, null, b, c);
    }
    le(a, b, c) {
        if (this.mv == null || this.mt == null || this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bi.bs, this.bi.br, this.mv.b8, d);
        e.c = this.getEffectiveViewport1(this.bi);
        let f = this.ek(a, b, c);
        f = this.mv.dt(f, e);
        let g = this.mw.c(a);
        if (!b && this.mt != null) {
            let h = this.fb(a, c);
            let i = this.e9(a, c);
            let j = this.nu(this.mt, this.bi.bs, this.bi.br, d);
            let k = new ScalerParams(0, this.bi.bs, this.bi.br, this.mt.b8, d);
            k.c = this.bs.m3;
            let l = this.d6(a, h, this.mt, k, j);
            let m = this.d6(a, i, this.mt, k, j);
            if (m <= l) {
                g = this.mt.dt(i, k) + j;
            }
            else {
                g = this.mt.dt(h, k) + j;
            }
        }
        let n = this.mw.d(g, f, this.bi.bs, this.bi.br);
        let o = this.mw.e(g, f, this.bi.bs, this.bi.br);
        return { $type: Point_$type, x: n, y: o };
    }
    get np() {
        return this.no;
    }
    set np(a) {
        if (this.no != a) {
            let b = this.no;
            this.no = a;
            this.raisePropertyChanged("ValueColumn", b, this.no);
        }
    }
    get oe() {
        return this.c(AnchoredRadialSeries.n5);
    }
    set oe(a) {
        this.h(AnchoredRadialSeries.n5, a);
    }
    an(a) {
        if (a != null && a == this.mt && this.np != null && this.np.count > 0) {
            return new AxisRange(0, this.np.count - 1);
        }
        if (a != null && a == this.mv && this.np != null && this.np.count > 0) {
            return new AxisRange(this.np.minimum, this.np.maximum);
        }
        return null;
    }
    is(a, b, c, d) {
        super.is(a, b, c, d);
        if (this.nj.ct.g$b(a, b, c, d)) {
            this.i6(false);
            this.ic();
        }
        let e = typeCast(NumericAxisBase.$, this.mv);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.np);
                    this.np = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.np = this.bw(this.n1);
                    this.nj.co.e(this.er);
                }
                if (e != null && !e.ck()) {
                    this.nj.co.e(this.er);
                    this.i6(false);
                }
                break;
            case AnchoredRadialSeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.np);
                    this.np = this.bw(this.n1);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.ck()) {
                    this.nj.co.e(this.er);
                    this.i6(false);
                }
                break;
            case "TrendLineBrush":
                this.jh();
                break;
            case "TrendLineType":
                this.ic();
                break;
        }
    }
    hs(a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.nj.co.e(this.er);
                break;
        }
        this.nj.ct.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.mv != null && !this.mv.ck()) {
                    this.i6(true);
                }
                break;
            case 1:
                if (this.mv != null && !this.mv.ck()) {
                    this.i6(true);
                }
                break;
            case 0:
                if (this.mv != null && !this.mv.ck()) {
                    this.i6(true);
                }
                break;
            case 2:
                if (this.n1 != null && this.nj.co.b > 0 && this.mv != null && !this.mv.ck()) {
                    this.i6(true);
                }
                break;
            case 3:
                if (d == this.n1) {
                    if (this.mv != null && !this.mv.ck()) {
                        this.i6(true);
                    }
                }
                break;
        }
    }
    dv(a, b, c) {
        let d = super.dv(a, b, c);
        let e = c;
        if (this.bz == null || this.bz.count == 0 || this.mt == null || this.np == null || this.mt.jr == 0 || this.mv == null || isInfinity(this.mv.jx) || isInfinity(this.mv.jw) || e.co.b < 1) {
            d = false;
        }
        return d;
    }
    getOffsetValue() {
        return this.nu(this.mt, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.mt.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    get_ns() {
        return false;
    }
    get ns() {
        return this.get_ns();
    }
    nu(a, b, c, d) {
        let e = 0;
        let f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.m8(), b, c, d);
                break;
        }
        if (a.b8) {
            e = -e;
        }
        return e;
    }
    nd(a, b) {
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.mt;
        let g = this.mv;
        let h = g.jx;
        let i = g.jw;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = this.lw();
        let k = 0;
        let l = b;
        let m = new CollisionAvoider();
        let n = 0;
        let o = b.co.d;
        n = this.nu(f, c, d, e);
        l.ct.q = this.mv.lc;
        l.ct.p = this.mv.lb;
        l.ct.r = (p, q) => this.nv(p, q, c, d);
        l.ct.s = (p, q) => this.nw(p, q, c, d);
        let p = ((() => {
            let $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        let q = ((() => {
            let $ret = new TrendResolutionParams();
            $ret.c = b.co.b;
            $ret.d = b.co.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = this.er;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.ct.t(a.p, this.nn, this.np, this.ny, (r) => this.mt.getScaledAngle(r), (r) => this.mv.li(r), q, p);
        let r = true;
        if (this.nt(b)) {
            o--;
        }
        for (let s = b.co.c; s <= o; ++s) {
            let t = s;
            if (t * b.co.b >= this.mt.jr) {
                t -= intDivide((this.mt.jr), b.co.b);
            }
            let u = b.co.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.li(u[1]);
                if (b.co.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.li(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.ns && this.nr()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    let v = Math.min(t * b.co.b, this.bz.count - 1);
                    let w = this.mw.d(u[0], u[1], c, d);
                    let x = this.mw.e(u[0], u[1], c, d);
                    let y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        let z = b.cp.item(k);
                        z.ak = v;
                        z.content.item = this.bz.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.ns && this.nr()) {
                    o++;
                }
            }
        }
        b.cp.count = k;
        return;
    }
    nv(a, b, c, d) {
        return this.mw.d(a, b, c, d);
    }
    nw(a, b, c, d) {
        return this.mw.e(a, b, c, d);
    }
    nt(a) {
        let b = a;
        return !this.ns && b.co.c == 0 && b.co.d == this.mt.jr;
    }
    ni(a, b, c) {
        let d = null;
        let e = c.bs;
        let f = c.br;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            let g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            let h = f.bottom + 10;
            let i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            let j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    }
    n4(a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.nq()) {
                a.add(this.oi);
                a.add(a._inner[0]);
                d.add(this.oi);
                d.add(d._inner[0]);
            }
        }
    }
    nr() {
        return !this.nq();
    }
    nq() {
        let a = this.bi.bs;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    }
    hp(a, b) {
        super.hp(a, b);
        let c = b;
        if (a) {
            c.cp.clear();
        }
        c.ct.g$d();
    }
    ne(a, b) {
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.lj(b);
        let g = b;
        g.ct.g$g(a.p);
        CategoryMarkerManager.b(this, a.m, g.cp, this.ly);
        g.cj();
        this.n3(d, c, e, f, g);
    }
    n3(a, b, c, d, e) {
        e.cu(a, b, c, d);
    }
    jh() {
        super.jh();
        if (this.fe < 0) {
            return;
        }
        this.nj.cv();
    }
    fq(a, b) {
        if (a == this.nj.ct.g$j) {
            return null;
        }
        return super.fq(a, b);
    }
    c8(a) {
        let b = this.bi.bs;
        b = b.copy();
        let c = this.bi.br;
        let d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.mt == null || this.np == null || this.mv == null) {
            return false;
        }
        if (d < 0 || d > this.np.count - 1) {
            return false;
        }
        let e = this.mt.getScaledAngle(d);
        let f = this.mv.li(this.np.item(d));
        if (isNaN_(f)) {
            f = (this.mv.lb + this.mv.lc) / 2;
        }
        let g = 0.5 + (Math.cos(e) * f);
        let h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    }
    i8(a, b) {
        super.i8(a, b);
        if (!this.dk) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        let c = typeCast(AnchoredRadialSeriesView.$, this.bh);
        c.co.e(this.er);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.de) {
            this.nm = new RadialFrame(3);
            this.nd(this.nm, c);
        }
        this.de = false;
        this.ne(this.nm, c);
        this.dk = false;
    }
    i5(a, b, c, d, e) {
        super.i5(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        g.co.e(this.er);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.nl == null) {
            this.nl = new RadialFrame(3);
        }
        this.nl.u();
        this.nd(this.nl, g);
        this.ne(this.nl, g);
    }
    hy(a) {
        super.hy(a);
        this.a2.exportTrendlineData(this, a, this.nj.ct.g$j);
    }
}
AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
AnchoredRadialSeries.n5 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
Type.dep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:n1:od', [2, null], 'TrendLineType:nn:ob', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:nx:oa', [1, 1.5], 'TrendLinePeriod:ny:n9', [1, 7], 'TrendLineZIndex:nz:oc', [1, 1], 'TrendLineBrush:of:n6', [Brush.$, null], 'TrendLineDashArray:og:n7', [DoubleCollection.$], 'TrendLineDashCap:oh:n8', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
export class AnchoredRadialSeriesView extends RadialBaseView {
    constructor(a) {
        super(a);
        this.cs = null;
        this.ct = null;
        this.co = new AnchoredRadialBucketCalculator(this);
        this.cs = a;
        this.ct = new RadialTrendLineManager();
    }
    cu(a, b, c, d) {
    }
    cv() {
        this.cs.oe = null;
        if (this.cs.of != null) {
            this.cs.oe = this.cs.of;
        }
        else {
            this.cs.oe = this.cs.kw;
        }
    }
    a2(a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cs.nn != 0 && !b) {
                let c = this.ct.g$j;
                c.ac = this.cs.nx;
                c._stroke = this.cs.oe;
                c.ai = this.cs.og;
                c.ad = this.cs.oh;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cs.mt.e2 != null) {
            a += "<span>${item." + this.cs.mt.e2 + "}</span><br/>";
        }
        a += "<span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cs.fs + ": </span><span class='ui-priority-primary'>" + "${item." + this.cs.n1 + "}</span></div>";
        return a;
    }
}
AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
